/*******************************************************************************
 * FoxSettingsUIPracticeMatch generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxSettingsUIPracticeMatch extends FoxSettingsUIBase within FoxMenuUI
    native(UI)
    config(UI);

enum EPracticeMatchSettings
{
    EPMS_Map,
    EPMS_GameMode,
    EPMS_NumBots,
    EPMS_MAX
};

struct native PracticeMapInfo
{
    var string InternalName;
    var string FriendlyName;

    structdefaultproperties
    {
        InternalName=""
        FriendlyName=""
    }
};

var array<PracticeMapInfo> MapInfoArray;
var array<string> FriendlyMapNames;
var array<string> GameModeNames;
var delegate<SortMapData> __SortMapData__Delegate;
var delegate<SortMapName> __SortMapName__Delegate;

function SetupSettingsScene()
{
    local int I;
    local FoxDataProvider_MapInfo MapInfoDataProvider;
    local bool bPlayGoStatus;
    local PracticeMapInfo PMI;

    Outer.as_addAdditionalButtonContainer("container", int(SettingsContainerProperties.X), int(SettingsContainerProperties.Y), 0, 0, 0, 100, "", "", SettingsContainerProperties.WidgetSpacing, SettingsContainerProperties.MaxListWidth, SettingsContainerProperties.MaxListHeight, true);
    as_addSettingsBG(0, 0);
    Outer.as_addAdditionalSettingsButtonContainer("Controls", int(SettingsDividerContainerProperties.X), int(SettingsDividerContainerProperties.Y), 0, 0, 0, 100, "", "", SettingsDividerContainerProperties.WidgetSpacing, SettingsDividerContainerProperties.MaxListWidth, SettingsDividerContainerProperties.MaxListHeight, false);
    FriendlyMapNames.Length = 0;
    bPlayGoStatus = !Outer.Outer.OnlineSub.GameDownloadInterface.IsGameComplete() || Outer.Outer.OnlineSub.GameDownloadInterface.DoesGameNeedRefresh();
    I = 0;
    J0x27A:
    // End:0x539 [Loop If]
    if(I < Outer.Outer.MenuItemsDataStore.MapProviders.Length)
    {
        MapInfoDataProvider = FoxDataProvider_MapInfo(Outer.Outer.MenuItemsDataStore.MapProviders[I]);
        // End:0x52B
        if(MapInfoDataProvider != none)
        {
            // End:0x452
            if(bPlayGoStatus)
            {
                // End:0x44F
                if(MapInfoDataProvider.bAvailableForPlayGo && MapInfoDataProvider.bAvailableForPractice)
                {
                    PMI.InternalName = MapInfoDataProvider.MapName;
                    PMI.FriendlyName = MapInfoDataProvider.FriendlyName;
                    MapInfoArray.AddItem(PMI);
                    FriendlyMapNames.AddItem(MapInfoDataProvider.FriendlyName);
                }
            }
            // End:0x52B
            else
            {
                // End:0x52B
                if(MapInfoDataProvider.bAvailableForPractice)
                {
                    PMI.InternalName = MapInfoDataProvider.MapName;
                    PMI.FriendlyName = MapInfoDataProvider.FriendlyName;
                    MapInfoArray.AddItem(PMI);
                    FriendlyMapNames.AddItem(MapInfoDataProvider.FriendlyName);
                }
            }
        }
        ++ I;
        // [Loop Continue]
        goto J0x27A;
    }
    FriendlyMapNames.Sort(SortMapName);
    GameModeNames.Length = 0;
    GameModeNames.AddItem(Localize("FOXGAMEMP_TDM", "gametypestring", "FoxGame"));
    GameModeNames.AddItem(Localize("FOXGAMEMP_DM", "gametypestring", "FoxGame"));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addOptionStepper(Outer.LocalizeMenuString("maplabel", "Menu"), "", FriendlyMapNames, 0, "ei_SettingChanged", string(0), true), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addOptionStepper(Outer.LocalizeMenuString("gamemode", "Menu"), "", GameModeNames, 0, "ei_SettingChanged", string(1), true), class'FoxSettingsWidget')));
    SettingsWidgets.AddItem(FoxSettingsWidget(Outer.Outer.GetVariableObject(Outer.as_addSlider(Outer.LocalizeMenuString("botslabel", "Menu"), "", 1.0, 15.0, 1.0, 9.0, "ei_NumBotsChanged", string(2)), class'FoxSettingsWidget')));
    as_addSettingsSpacer();
    Outer.as_addConsoleSettingsButton(Outer.LocalizeMenuString("LaunchPracticeMatchLabel", "Menu"), Outer.LocalizeMenuString("LaunchPracticeMatchTooltip", "Menu"), "ei_LaunchPracticeMatch");
    //return;    
}

delegate int SortMapData(PracticeMapInfo S1, PracticeMapInfo S2)
{
    return ((S1.FriendlyName > S2.FriendlyName) ? -1 : 0);
    //return ReturnValue;    
}

delegate int SortMapName(string S1, string S2)
{
    return ((S1 > S2) ? -1 : 0);
    //return ReturnValue;    
}

function ei_NumBotsChanged(string NewValueString)
{
    CurrentVals[2] = float(int(float(NewValueString) + 0.10));
    //return;    
}

function GetOriginalVals()
{
    OriginalVals[0] = 0.0;
    OriginalVals[1] = 0.0;
    OriginalVals[2] = 9.0;
    //return;    
}

function GetDefaultVals()
{
    DefaultVals[0] = 0.0;
    DefaultVals[1] = 0.0;
    DefaultVals[2] = 9.0;
    //return;    
}

function BeginClose(optional bool bSkipTransition)
{
    bSkipTransition = false;
    ApplyChanges();
    OnSettingsClose();
    // End:0x76
    if(NextSettingsClass != none)
    {
        Outer.Outer.PendingCommandGroupName = "matchSettingsNextPage";
    }
    // End:0x96
    else
    {
        Outer.Settings = none;
    }
    Outer.Outer.as_transition(Outer.SettingsOutTransition);
    //return;    
}

protected function SetupButtonContainer()
{
    // End:0xF8
    if(class'WorldInfo'.static.IsConsoleBuild())
    {
        Outer.as_addAdditionalButtonContainer("container", 1000, 255, 0, 0, 0, 100, "", "", 15, 1200, 1200, false);
        as_addSettingsButtonPrompt(Outer.LocalizeMenuString("CancelPrivateMatchLabel_X", "Menu"), Outer.LocalizeMenuString("CancelPrivateMatchTooltip", "Menu"), false, "");
    }
    //return;    
}

private final function ei_LaunchPracticeMatch(optional bool SkipUpdate)
{
    LaunchGame();
    //return;    
}

event LaunchGame()
{
    local string CommandString;
    local int SelectedGameMode, MapIndex;

    SelectedGameMode = Round(CurrentVals[1]);
    MapIndex = Max(MapInfoArray.Find('FriendlyName', FriendlyMapNames[int(CurrentVals[0])]), 0);
    CommandString = "start ";
    CommandString $= MapInfoArray[MapIndex].InternalName;
    CommandString $= "?game=";
    switch(SelectedGameMode)
    {
        // End:0xF5
        case 0:
            CommandString $= "tdm";
            // End:0x179
            break;
        // End:0x115
        case 1:
            CommandString $= "dm";
            // End:0x179
            break;
        // End:0x137
        case 2:
            CommandString $= "lts";
            // End:0x179
            break;
        // End:0x159
        case 3:
            CommandString $= "lms";
            // End:0x179
            break;
        // End:0xFFFF
        default:
            CommandString $= "tdm";
            // End:0x179
            break;
    }
    CommandString $= "?NumBots=";
    CommandString $= string(int(CurrentVals[2] + 0.10));
    CommandString $= "?TimeLimit=10";
    switch(SelectedGameMode)
    {
        // End:0x229
        case 0:
            CommandString $= "?GoalScore=90";
            // End:0x26C
            break;
        // End:0x256
        case 1:
            CommandString $= "?GoalScore=3000";
            // End:0x26C
            break;
        // End:0x25E
        case 2:
            // End:0x26C
            break;
        // End:0x266
        case 3:
            // End:0x26C
            break;
        // End:0xFFFF
        default:
            // End:0x26C
            break;
    }
    Outer.Outer.ui_ConsoleCommand(CommandString);
    //return;    
}
